#include <stdio.h>
#include <windows.h>
#include <commctrl.h>
#include "main.h"
#include "dialog1.h"
#include "dialog2.h"

HINSTANCE g_hInst;
HWND g_hWnd,g_hwndStatus,g_hwndScroll;
int paintcount,ColumnCount=0,LineCount=0,Zoom=1,Pairmode=0;
float Scale=60;
FILE *datei=0;

struct
 {
 char name[32];
 char einheit[10];
 COLORREF farbe;
 int aktiv;
 double letzter;
 }
 ColRec, *Spalten=0;

BOOL WINAPI Dialog1_DlgProc(HWND hWnd,
                    UINT wMsg,
                    WPARAM wParam,
                    LPARAM lParam);
                    
BOOL WINAPI Dialog2_DlgProc(HWND hWnd,
                    UINT wMsg,
                    WPARAM wParam,
                    LPARAM lParam);
                    

/* liefert den nchsten teilstring */
char *parse(char *cp)
 {
 char *cp2;
 cp+=strlen(cp);        /*jetzt zeigt er auf das NULL-Zeichen*/
 cp++;
 if(cp2=strchr(cp,';')) *cp2=0; /*Spaltentrennzeichen*/
 return cp;
 }


int FileClose()
 {
 if(datei)
  {
  fclose(datei);
  datei=0;
  ColumnCount=0;
  if(Spalten) free(Spalten);
  }
 return 0;
 }

int FileOpen(char *name)
 {
 char st1[1500],*cp;
 int a;
 float x;
 SCROLLINFO si;
 if(datei) 
  {
   FileClose();
  }
 datei=fopen(name,"r");
 if(!datei)
  {
  MessageBox(0,"Datei konnte nicht geffnet werden","Fehler",MB_OK);
  return 0;
  }
 fgets(st1,1490,datei);
 if(cp=strchr(st1,'\n')) *cp=0;  /*Zeilenendezeichen umwandeln*/
 if(cp=strchr(st1,';')) *cp=0;  /*erster Separator*/
 
 /* jetzt die Kopfzeile parsen (wie viele Spalten?) */
 cp=st1;
 if(strcmp(cp,"Datum"))
  {
  FileClose(datei);
  MessageBox(0,"Datei hat falsches Format (Spalte 1 ungleich Datum)!",name,MB_OK);
  datei=0;
  return 0;
  }
 cp=parse(cp);
 if(strcmp(cp,"Zeit"))
  {
  FileClose(datei);
  MessageBox(0,"Datei hat falsches Format (Spalte 2 ungleich Zeit)!",name,MB_OK);
  datei=0;
  return 0;
  }
 do
  {
  cp=parse(cp);
  ColumnCount++;
  }
 while (strlen(cp));
 ColumnCount--;
 Spalten=calloc(ColumnCount,sizeof(ColRec));
 
 /* Jetzt die Kpfe vorbereiten */
 cp=st1+strlen(st1)+1; /*Das war das Datum*/
 cp=cp+strlen(cp)+1; /*Das war die Uhrzeit*/
 for(a=0;a<ColumnCount;a++)
  {
  int farbe,rot,gruen,blau;
  float winkel;
  const float pi   = 3.1418;
  strcpy(Spalten[a].name,cp);
  strcpy(Spalten[a].einheit,"Test");
  winkel=2*pi*a/ColumnCount;
  rot=127*(1+sin(winkel));
  gruen=127*(1+sin(winkel+(pi/3*2)));
  blau=127*(1+sin(winkel+2*(pi/3*2)));
  if(rot<0) rot=0;
  if(gruen<0) gruen=0;
  if(blau<0) blau=0;
  Spalten[a].farbe=RGB(rot,gruen,blau);
  Spalten[a].aktiv=1;
  cp=cp+strlen(cp)+1; /*weiterzhlen*/
  }
 Scale=0;
 do
  {
   fgets(st1,1490,datei);
   cp=st1;
   while (cp=strchr(cp,',')) *cp='.';
   if(!feof(datei))
   {
   LineCount++;
   /* Maxima suchen */
   if(cp=strchr(st1,'\n')) *cp=0;  /*Zeilenendezeichen umwandeln*/
   if(cp=strchr(st1,';')) *cp=0;  /*erster Separator*/

   cp=parse(st1);

   for(a=0;a<ColumnCount;a++)
     {
     cp=parse(cp); /*weiterzhlen*/
     sscanf(cp,"%f",&x);
     if(x>Scale) Scale=x;
     }
    }
  } 
  while(!feof(datei));
 rewind(datei); 
 sprintf(st1,"%E",Scale);
 if(cp=strchr(st1,'.'))
  {
   cp++;
   while(*cp !='E') 
   {
    *cp='0';
    cp++;
   }
  }
 sscanf(st1,"%E",&Scale); 

 if(Scale==0) Scale=1;
 /* Rollbalken initialisieren*/
 si.fMask=SIF_POS|SIF_RANGE;
 si.nMin=0;
 si.nMax=LineCount;
 si.nPos=0;
 SetScrollInfo(g_hwndScroll,SB_CTL,&si,TRUE);
 sprintf(st1,"geffnet:%s %d Spalten %d Zeilen, Max=%f",name,ColumnCount,LineCount,Scale);
 SendMessage(g_hwndStatus,SB_SETTEXT,(WPARAM) 0,(LPARAM) st1);
 sprintf(st1,"%s - Ingos CSV-Viewer",name);
 SendMessage(g_hWnd,WM_SETTEXT,0,(LPARAM) st1);
 return 0;
 }

LRESULT CALLBACK WndProc (HWND, UINT, WPARAM, LPARAM);

#pragma argsused
int APIENTRY WinMain(HINSTANCE hInstance,
			HINSTANCE hPrevInstance,
			LPSTR	lpCmdLine,
			int	nCmdShow)
	{
	g_hInst=hInstance;
	InitCommonControls();
	WNDCLASS WndClass;
	WndClass.style =CS_OWNDC | CS_VREDRAW | CS_HREDRAW;
	WndClass.cbClsExtra=0;	
	WndClass.cbWndExtra=0;
	WndClass.lpfnWndProc=WndProc;
	WndClass.hInstance=hInstance;	
	WndClass.hbrBackground=(HBRUSH)(COLOR_WINDOW+1);	
	WndClass.hCursor=LoadCursor(NULL,IDC_ARROW);
	WndClass.hIcon=LoadIcon(hInstance,MAKEINTRESOURCE(IDI_ICON1));
	WndClass.lpszMenuName=MAKEINTRESOURCE(IDM_MENU1);
	WndClass.lpszClassName="WinProg";
	RegisterClass(&WndClass);
	
	g_hWnd=CreateWindow("WinProg","keine Datei - Ingos CSV-Viewer",WS_OVERLAPPEDWINDOW,
				0,0,800,600,NULL,NULL,hInstance,NULL);
	ShowWindow(g_hWnd,nCmdShow);
	UpdateWindow((g_hWnd));
	
	MSG Message;
	while (GetMessage(&Message,NULL,0,0))
	 {
	 DispatchMessage(&Message);
	 TranslateMessage(&Message);
	 }
	 return(Message.wParam);	 
      }


LRESULT CALLBACK WndProc (HWND hWnd, UINT uiMessage,
					WPARAM wParam, LPARAM lParam)
	{

	  switch(uiMessage)
	  {
	   case WM_DESTROY:
	     PostQuitMessage(0);
	     return 0;
	   case WM_CREATE:
	    { 
	     char st1[300],*cp,*cp1;
             SCROLLINFO si;
	     /* StatusBar erzeugen */
	     g_hwndStatus = CreateWindowEx( 
			0,                       // no extended styles 
			STATUSCLASSNAME,         // name of status window class 
			(LPCTSTR) NULL,          // no text when first created 
			SBARS_SIZEGRIP |         // includes a sizing grip 
			WS_VISIBLE |
			WS_CHILD,                // creates a child window 
			0, 0, 0, 0,              // ignores size and position 
			hWnd,              	      // handle to parent window 
			(HMENU) 0,       // child window identifier 
			g_hInst,                   // handle to application instance 
			NULL);                   // no window creation data 

              /* Scrollbar erzeugen */
              g_hwndScroll = CreateWindowEx(  
                        0,                          /* no extended styles        */ 
                        "ScrollBar",                 /* scroll bar control class  */ 
                        (LPSTR) NULL,                /* text for window title bar */ 
                        WS_CHILD|SBS_HORZ|WS_VISIBLE,/* scroll bar styles         */ 
                        0,                           /* horizontal position       */ 
                        0,                           /* vertical position         */ 
                        160,                         /* width of the scroll bar   */ 

                        26,                     /* height            */ 
                        hWnd,                   /* handle of main window          */ 
                        (HMENU) NULL,           /* no menu for a scroll bar       */ 
                        g_hInst,                /* instance owning this window    */ 
                        (LPVOID) NULL           /* pointer not needed             */ 
                        );

	      /* Rollbalken initialisieren*/
	      si.fMask=SIF_POS|SIF_RANGE;
	      si.nMin=0;
	      si.nMax=100;
	      si.nPos=50;
	      SetScrollInfo(g_hwndScroll,SB_CTL,&si,TRUE);



	      /* Datei in der Kommandozeile angegeben? */
		strcpy(st1,GetCommandLine());
		cp=st1;
		if(*cp=='"') /*erstes Gnsefsschen vom Programmnamen*/
		 {
		 cp=strchr(cp+1,'"'); /*zweites Gnsefsschen suchen*/
		 if(!cp) return 0;   /*kein schliessendes*/
		 cp++;
		 }
		else
		 {
		 cp=strchr(cp,' '); /* Knnen auch mehrere Leerzeichen sein */
		 } 
		/*Jetzt sollten wir den Programmnamen bersprungen haben*/ 
                if(!cp) return 0;

                while (*cp==' ') cp++; /*fllende Leerzeichen berspringen*/


                if(!strlen(cp)) return 0; /*kein Dateiname angegeben*/
                
		 
		if(*cp=='"')    /* Dateiname ist auch eingepackt! */
                 {
		 cp++;
		 if(cp1=strchr(cp,'"')) *cp1=0;
		 }
		FileOpen(cp);
		strcat(cp," - Ingos CSV-Viewer");
		SendMessage(hWnd,WM_SETTEXT,0,(LPARAM) cp);

	     }
	     return 0;

	    case WM_SIZE:
	     {
             int i,nw,inc,width[10];
             char puffer[30];
	     RECT rcClient;
             GetClientRect(hWnd, &rcClient);
             //einfach an den StatusBar weitergeben
             SendMessage(g_hwndStatus,WM_SIZE,wParam,lParam);
             //ScrollBar anordnen
             MoveWindow(g_hwndScroll,0,HIWORD(lParam)-32,
                              LOWORD(lParam),15,TRUE);
	     }
	     return 0;
	      
	    case WM_PAINT:
	     {
      		PAINTSTRUCT ps;
      		HDC hdc;
      		HPEN *Stifte,penalt,Schwarz,Grau;
      		HBRUSH brush,brushalt;
		RECT rcClient;
      		HFONT hfnt;
      		LOGFONT lf;
                SCROLLINFO si;
                
		char st1[1500],*cp,*cp1,date[40],olddate[40],time[40];
		int a,x,xscale,ystep,lastdate=0,lasttime=0;
		double v;
      		hdc=BeginPaint(hWnd,&ps);
      		if(!datei)
      		 {
      		 EndPaint(hWnd,&ps);
      		 return 0;
      		 }
      		Stifte=calloc(ColumnCount,sizeof(HPEN));
      		for(a=0;a<ColumnCount;a++)
      		Stifte[a]=CreatePen(PS_SOLID,1,Spalten[a].farbe);
                Schwarz=CreatePen(PS_SOLID,1,0);
                Grau=CreatePen(PS_SOLID,1,0xe0e0e0);
//      		brush=CreateSolidBrush(RGB(254,254,0));
      		penalt=(HPEN)SelectObject(hdc,Schwarz);      
//      		brushalt=(HBRUSH)SelectObject(hdc,brush);      
		GetClientRect(hWnd, &rcClient);
		rcClient.left+=3;
		rcClient.top+=3;
		rcClient.bottom-=40;
		rcClient.right-=3;
		
      		
		/* Die Palette ausgeben */
      		SetTextAlign(hdc,TA_LEFT); 
      		if(datei)
      		xscale=rcClient.right/(ColumnCount+1);

      		ZeroMemory(&lf,sizeof(LOGFONT));
      		strcpy(lf.lfFaceName,"Courier New");
      		lf.lfHeight=12;
      		lf.lfWidth=10;
      		lf.lfWeight=FW_NORMAL;
      		lf.lfEscapement=0;
      		hfnt=CreateFontIndirect(&lf);
      		SelectObject(hdc,hfnt);
      		DeleteObject(hfnt);


      		for (a=0;a<ColumnCount;a+=2)
      		 {
      		 SetTextColor(hdc,0x0);
                 if(Spalten[a].aktiv)
                  SetBkColor(hdc,Spalten[a].farbe);
                 else
                  SetBkColor(hdc,0xffffff);
      		 TextOut(hdc,4+xscale*a,rcClient.bottom-18,Spalten[a].name,strlen(Spalten[a].name));

                 if(Spalten[a+1].aktiv)
                   {
                   if(!Pairmode) SetBkColor(hdc,Spalten[a+1].farbe);
                   }
                 else
                  if(!Pairmode) SetBkColor(hdc,0xffffff);
      		 TextOut(hdc,4+xscale*a,rcClient.bottom-5,Spalten[a+1].name,strlen(Spalten[a+1].name));
      		 }

                /* Die Skala ausgeben */
                ystep=10;       /* Anzahl Skaleneintrge */
                if(rcClient.bottom-105>200) ystep=20;
                if(rcClient.bottom-105>450) ystep=50;
                SelectObject(hdc,Grau); /* zum linien Zeichnen */
                SetBkColor(hdc,0xffffff);
                for(a=0;a<(ystep+1);a++)
                 {
                 v=Scale*a/ystep;
                 if(Pairmode) v*=2;
                 if(Scale>100) sprintf(st1,"%7.0lf",v);
                 else sprintf(st1,"%6.2lf",v);
      		 TextOut(hdc,2,rcClient.bottom-105-((rcClient.bottom-110)*a/ystep),st1,strlen(st1));
      		 MoveToEx(hdc,60,rcClient.bottom-100-((rcClient.bottom-110)*a/ystep),NULL);
      		 LineTo(hdc,rcClient.right,rcClient.bottom-100-((rcClient.bottom-110)*a/ystep));
                 }

                /* Die Kurven Zeichnen */
                rewind (datei);
                fgets(st1,1490,datei); /* Die Kopfzeile haben wir schon */

                /* evtl Zeilen berspringen */
                si.cbSize=sizeof(SCROLLINFO);
                si.fMask=SIF_POS;
	        GetScrollInfo(g_hwndScroll,SB_CTL,&si);
                if(si.nPos)
                for(a=0;a<si.nPos;a++)
                 {
                  fgets(st1,1490,datei); /* eine Zeile einlesen */
                 }
                x=60;
                fgets(st1,1490,datei); /* erste Zeile einlesen */
                cp=st1;
                while (cp=strchr(cp,',')) *cp='.';
                if(cp=strchr(st1,'\n')) *cp=0;  /*Zeilenendezeichen umwandeln*/
                if(cp=strchr(st1,';')) *cp=0;  /*erster Separator*/
                cp=st1;         /* das ist das Datum */
                strcpy(date,cp);
                cp=parse(cp);   /* das ist die Zeit */
                strcpy(time,cp);
                for(a=0;a<ColumnCount;a++)
                 {
                  cp=parse(cp);
                  sscanf(cp,"%lf",&v);
                  if(Pairmode)
                    {
                    double v2;
                    cp=parse(cp);
                    sscanf(cp,"%lf",&v2);
                    v=(v+v2)/2;
                    }                   
                  v=v*(rcClient.bottom-110)/Scale;
                  Spalten[a].letzter=v;
                  if(Pairmode) a++;
                 }
                strcpy(olddate,"");
                while ((x<rcClient.right)&&(!feof(datei)))
                 {                
                 fgets(st1,1490,datei); /* nchste Zeile einlesen */
                 cp=st1;
                 while (cp=strchr(cp,',')) *cp='.';
                 if(cp=strchr(st1,'\n')) *cp=0;  /*Zeilenendezeichen umwandeln*/
                 if(cp=strchr(st1,';')) *cp=0;  /*erster Separator*/
                 cp=st1;         /* das ist das Datum */
                 strcpy(date,cp);
                 cp=parse(cp);   /* das ist die Zeit */
                 strcpy(time,cp);

                 /* vertikale Gitterlinien zeichen */
                 if(!strcmp(time,"00:00"))
                  {
       		   SelectObject(hdc,Schwarz);
      		   MoveToEx(hdc,x+1,rcClient.bottom-100,NULL);
      		   LineTo(hdc,x+1,5);                  
                  }
                 else if((!strcmp(time+3,"00"))&&(Zoom>2))
                  {
       		   SelectObject(hdc,Grau);
      		   MoveToEx(hdc,x+1,rcClient.bottom-100,NULL);
      		   LineTo(hdc,x+1,5);                                    
                  }

                 for(a=0;a<ColumnCount;a++)
                  {
                   cp=parse(cp);
                   if(Spalten[a].aktiv)
                   {
                   sscanf(cp,"%lf",&v);
                   if(Pairmode)
                    {
                    double v2;
                    cp=parse(cp);
                    sscanf(cp,"%lf",&v2);
                    v=(v+v2)/2;
                    }
                   v=v*(rcClient.bottom-110);
                   v=v/Scale;
       		   SelectObject(hdc,Stifte[a]);
      		   MoveToEx(hdc,x,rcClient.bottom-100
      		                    -(Spalten[a].letzter),NULL);
      		   LineTo(hdc,x+Zoom,rcClient.bottom-100
      		                    -(v));
                   Spalten[a].letzter=v;
                   }
                   else
                   {
                   if(Pairmode)
                    {
                    double v2;
                    cp=parse(cp);
                    }                   
                   }
                   if(Pairmode) a++;
                  }
                 if((x-lastdate>20)&&(strcmp(date,olddate))
                     &&(x+70<rcClient.right))
                  {
      		  HFONT hfnt;
      		  LOGFONT lf;
      		  ZeroMemory(&lf,sizeof(LOGFONT));
      		  strcpy(lf.lfFaceName,"Courier New");
      		  lf.lfHeight=12;
      		  lf.lfWidth=10;
      		  lf.lfWeight=FW_NORMAL;
      		  lf.lfEscapement=0;
      		  hfnt=CreateFontIndirect(&lf);
      		  SelectObject(hdc,hfnt);
                  DeleteObject(hfnt);
                  SetBkColor(hdc,0xffffff);
                  SetTextColor(hdc,0);
      		  TextOut(hdc,x,rcClient.bottom-35,date,strlen(date));
                  lastdate=x;
                  strcpy(olddate,date);
                  }

                 if((x-lasttime>15)&&(!strcmp(time+3,"00")))
                  {
      		  HFONT hfnt;
      		  LOGFONT lf;
      		  ZeroMemory(&lf,sizeof(LOGFONT));
      		  strcpy(lf.lfFaceName,"Courier New");
      		  lf.lfHeight=12;
      		  lf.lfWidth=10;
      		  lf.lfWeight=FW_NORMAL;
      		  lf.lfEscapement=900;
      		  hfnt=CreateFontIndirect(&lf);
      		  SelectObject(hdc,hfnt);
                  DeleteObject(hfnt);
                  SetBkColor(hdc,0xffffff);
                  SetTextColor(hdc,0);
      		  TextOut(hdc,x-4,rcClient.bottom-40,time,strlen(time));
                  lasttime=x;
                  }

                 if(!strcmp(time,"00:00"))
                  {
       		   SelectObject(hdc,Schwarz);
      		   MoveToEx(hdc,x+1,rcClient.bottom-100,NULL);
      		   LineTo(hdc,x+1,rcClient.bottom-90);                  
                  }
                 else if(!strcmp(time+3,"00"))
                  {
       		   SelectObject(hdc,Schwarz);
      		   MoveToEx(hdc,x+1,rcClient.bottom-100,NULL);
      		   LineTo(hdc,x+1,rcClient.bottom-95);                                    
                  }



                 x+=Zoom;
                 }

//		SelectObject(hdc,brushalt);
		SelectObject(hdc,penalt);
                for(a=0;a<ColumnCount;a++)
      		DeleteObject(Stifte[a]);
      		DeleteObject(Schwarz);
      		DeleteObject(Grau);
      		DeleteObject(brush);
		ReleaseDC(hWnd,hdc);
      		EndPaint(hWnd,&ps);
	     }	
	    return 0;

            case WM_MOUSEMOVE:
             {
             char st1[100];
             int x,y;
             x=LOWORD(lParam);
             y=HIWORD(lParam);
             sprintf(st1,"%4d / %4d",x,y);
             SendMessage(g_hwndStatus,SB_SETTEXT,(WPARAM) 0,(LPARAM) st1);
             }
             return 0;

            case WM_HSCROLL:
	     {
             SCROLLINFO si;
             switch(LOWORD(wParam))
              {
              case SB_THUMBPOSITION:
               {
	       si.cbSize=sizeof(si);
	       si.fMask=SIF_POS;
	       si.nPos=HIWORD(wParam);
	       SetScrollInfo((HWND) lParam,SB_CTL,&si,TRUE);
               InvalidateRect(hWnd,0,TRUE);
	       }
	       return 0;
	       
	      case SB_PAGELEFT:
	       {
	       si.cbSize=sizeof(si);
	       si.fMask=SIF_POS;
	       GetScrollInfo((HWND) lParam,SB_CTL,&si);
	       si.nPos-=96;
	       si.cbSize=sizeof(si);
	       si.fMask=SIF_POS;
	       SetScrollInfo((HWND) lParam,SB_CTL,&si,TRUE);
               InvalidateRect(hWnd,0,TRUE);
	       }
	       return 0; 

	      case SB_PAGERIGHT:
	       {
	       si.cbSize=sizeof(si);
	       si.fMask=SIF_POS;
	       GetScrollInfo((HWND) lParam,SB_CTL,&si);
	       si.nPos+=96;
	       si.cbSize=sizeof(si);
	       si.fMask=SIF_POS;
	       SetScrollInfo((HWND) lParam,SB_CTL,&si,TRUE);
               InvalidateRect(hWnd,0,TRUE);
	       }
	       return 0; 

	      case SB_LINELEFT:
	       {
	       si.cbSize=sizeof(si);
	       si.fMask=SIF_POS;
	       GetScrollInfo((HWND) lParam,SB_CTL,&si);
	       si.nPos-=4;
	       si.cbSize=sizeof(si);
	       si.fMask=SIF_POS;
	       SetScrollInfo((HWND) lParam,SB_CTL,&si,TRUE);
               InvalidateRect(hWnd,0,TRUE);
	       }
	       return 0; 

	      case SB_LINERIGHT:
	       {
	       si.cbSize=sizeof(si);
	       si.fMask=SIF_POS;
	       GetScrollInfo((HWND) lParam,SB_CTL,&si);
	       si.nPos+=4;
	       si.cbSize=sizeof(si);
	       si.fMask=SIF_POS;
	       SetScrollInfo((HWND) lParam,SB_CTL,&si,TRUE);
               InvalidateRect(hWnd,0,TRUE);
	       }
	       return 0; 


	      }
              return 0;
              }

            case WM_LBUTTONDOWN:
             {
             char st1[200];
             int x,y,xscale;
             RECT rcClient;
             x=LOWORD(lParam);
             y=HIWORD(lParam);
             GetClientRect(hWnd,&rcClient);
             rcClient.left+=3;
             rcClient.top+=3;
             rcClient.bottom-=40;
             rcClient.right-=3;

             if(y>rcClient.bottom-20)
              {
               /* Die Palette */
               y-=rcClient.bottom;
	       xscale=rcClient.right/(ColumnCount+1);
	       x/=xscale;
	       x/=2;
	       x*=2;
	       if((y>-6)&&(!Pairmode)) x++;
               /* x hat jetzt den gewhlten Kanal! */
               if(x<ColumnCount)
	       DialogBoxParam(g_hInst,MAKEINTRESOURCE(IDD_DIALOG1),
	                      hWnd,Dialog1_DlgProc,x);
               InvalidateRect(hWnd,0,TRUE);

              }
             }
             return 0;

  	    case WM_CONTEXTMENU:
             //wParam enthlt das hWnd des Fenster oder Controls!
             {
             HMENU hmenu,hmenuTrack;
        
             hmenu=LoadMenu(g_hInst,MAKEINTRESOURCE(IDM_MENU2));
             hmenuTrack = GetSubMenu(hmenu, 0);
	      TrackPopupMenuEx(hmenuTrack,
                       TPM_LEFTBUTTON,
                       LOWORD(lParam),HIWORD(lParam),
                       hWnd,
                       NULL);
             DestroyMenu(hmenu);
             return 0;
             }

	   case WM_COMMAND:
	     switch (LOWORD(wParam))
	     {

             case CM_DATEIOEFFNEN:
              {
                OPENFILENAME ofn;
                char FileName[300];
                ZeroMemory(&ofn,sizeof(ofn));
                strcpy(FileName,"*.csv");
                ofn.lStructSize=sizeof(ofn);
                ofn.lpstrFilter="CSV-Dateien\0*.csv\0"
                                "Texttateien\0*.txt\0"
                                "alle Dateien\0*.*\0";
                ofn.hwndOwner=hWnd;
                ofn.lpstrFile=FileName;
                ofn.nMaxFile=300;
                ofn.lpstrTitle="Datei zum ffnen whlen!";
                ofn.Flags=OFN_FILEMUSTEXIST;
	             
                if(GetOpenFileName(&ofn))
                 {
                  FileOpen(FileName);
                 }
               InvalidateRect(hWnd,0,TRUE);
              }
              return 0;
              
             case CM_GROESSER:
              {
              Zoom*=2;
              InvalidateRect(hWnd,0,TRUE);
              }
              return 0;
             
             case CM_KLEINER:
              {
              if(Zoom>1) Zoom/=2;
              InvalidateRect(hWnd,0,TRUE);
              }
              return 0;  

             case CM_VGROESSER:
              {
              char st1[16],*cp;
              Scale/=2;
              sprintf(st1,"%E",Scale);
              if(cp=strchr(st1,'.'))
               {
               cp++;
               while(*cp !='E') 
                {
                *cp='0';
                cp++;
                }
               }
              sscanf(st1,"%E",&Scale); 
              InvalidateRect(hWnd,0,TRUE);
              }
              return 0;
             
             case CM_VKLEINER:
              {
              char st1[16],*cp;
              Scale*=2;
              sprintf(st1,"%E",Scale);
              if(cp=strchr(st1,'.'))
               {
               cp++;
               while(*cp !='E') 
                {
                *cp='0';
                cp++;
                }
               }
              sscanf(st1,"%E",&Scale); 
              InvalidateRect(hWnd,0,TRUE);
              }
              return 0;  


             case WM_KEYDOWN:
              {
              /* Ans Scrollbar weitergeben */
              SendMessage(g_hwndScroll,WM_KEYDOWN,wParam,lParam);
              }
              return 0;

	     case CM_DATEIBEENDEN:
	       FileClose();
	       PostQuitMessage(0);
	       return 0;

             case CM_LIZENZ:
              {
       	       DialogBoxParam(g_hInst,MAKEINTRESOURCE(IDD_DIALOG2),
                      hWnd,Dialog2_DlgProc,0);
              }
              return 0;
	     }
            return 0;
	   default:
	     return DefWindowProc (hWnd, uiMessage, wParam, lParam);  
	  }
	}






BOOL WINAPI Dialog1_DlgProc(HWND hWnd,
                    UINT wMsg,
                    WPARAM wParam,
                    LPARAM lParam)
   {
   static int Spalte;
   switch (wMsg)
     {
     case WM_INITDIALOG:
      {
       Spalte=lParam;
       SendMessage(hWnd,WM_SETICON,ICON_BIG,(LPARAM)LoadIcon(g_hInst,MAKEINTRESOURCE(IDI_ICON1)));
       SendMessage(hWnd,WM_SETTEXT,0,(LPARAM) Spalten[Spalte].name);
       SendMessage(GetDlgItem(hWnd,IDC_EDIT1),WM_SETTEXT,0,(LPARAM) Spalten[Spalte].name);
       if(Spalten[Spalte].aktiv) SendMessage(GetDlgItem(hWnd,IDC_VISIBLE),BM_SETCHECK,BST_CHECKED,0);
       else SendMessage(GetDlgItem(hWnd,IDC_VISIBLE),BM_SETCHECK,BST_UNCHECKED,0);
       if(Pairmode) SendMessage(GetDlgItem(hWnd,IDC_PAIRMODE),BM_SETCHECK,BST_CHECKED,0);
       else SendMessage(GetDlgItem(hWnd,IDC_PAIRMODE),BM_SETCHECK,BST_UNCHECKED,0);
      }
      break;
     case WM_COMMAND:
      {
      switch (LOWORD(wParam))
       {
       case IDC_OK:
        {
         char st1[100];
         /* Eingegebene Werte speichern */

         SendMessage(GetDlgItem(hWnd,IDC_EDIT1),WM_GETTEXT,20,(LPARAM) Spalten[Spalte].name);
         if(SendMessage(GetDlgItem(hWnd,IDC_VISIBLE),BM_GETCHECK,0,0)==BST_CHECKED)
          Spalten[Spalte].aktiv=1;
         else
          Spalten[Spalte].aktiv=0;
         if(SendMessage(GetDlgItem(hWnd,IDC_PAIRMODE),BM_GETCHECK,0,0)==BST_CHECKED)
          Pairmode=1;
         else
          Pairmode=0;
         EndDialog(hWnd,1);
        }
        break;
        
       case IDC_COLORSEL:
        {
        CHOOSECOLOR chk;
        COLORREF cc[16];
        ZeroMemory(&chk,sizeof(chk));
        chk.lStructSize=sizeof(chk);
        chk.hwndOwner=hWnd;
        chk.rgbResult=Spalten[Spalte].farbe;
        chk.lpCustColors=cc;
        chk.Flags=CC_RGBINIT;
        if(ChooseColor(&chk)) Spalten[Spalte].farbe=chk.rgbResult;
        }
        break;
       
       case IDC_OTHERSOFF:
        {
        int a;
        for(a=0;a<ColumnCount;a++)
         {
         if(a!=Spalte) Spalten[a].aktiv=0;
         }
        SendMessage(GetDlgItem(hWnd,IDC_VISIBLE),BM_SETCHECK,BST_CHECKED,0); 
        }
        break;
                
       }  
      }
     break;
     case WM_SYSCOMMAND:
      {
       switch(wParam)
        {
         case SC_CLOSE:
         {
         EndDialog(hWnd,0);
         }
         break;
        }
      }
      break;  
     }
   return FALSE; 
   }


BOOL WINAPI Dialog2_DlgProc(HWND hWnd,
                    UINT wMsg,
                    WPARAM wParam,
                    LPARAM lParam)
   {
   switch (wMsg)
     {
     case WM_INITDIALOG:
      {
      char st1[65536],*cp,*cp1;
      FILE *datei;
      SendMessage(hWnd,WM_SETTEXT,0,(LPARAM) "Lizenzinformationen");
      GetModuleFileName(0,st1,290);
      cp=strrchr(st1,'\\');     /* wollen nur das Verzeichnis */
      if(cp) strcpy(cp,"\\gpl.txt");
      datei=fopen(st1,"rb");
      if(datei)
      {
      cp=st1;
      while(!feof(datei))
       {
       fgets(cp,200,datei);
       if(cp1=strchr(cp,13)) *cp1=0;
       strcat(cp,"\r\n");
       cp+=strlen(cp);
       }
      fclose(datei);
      cp=st1;
//      while(cp=strchr(cp,10)) *cp=13;
      }
      SendMessage(GetDlgItem(hWnd,IDC_DLG2_EDIT),WM_SETTEXT,0,(LPARAM) st1);
      }
      break;
     case WM_COMMAND:
      {
      switch (LOWORD(wParam))
       {
       case IDC_DLG2_OK:
        {
         EndDialog(hWnd,1);
        }
        break;                        
       }  
      }
     break;
     case WM_SYSCOMMAND:
      {
       switch(wParam)
        {
         case SC_CLOSE:
         {
         EndDialog(hWnd,0);
         }
         break;
        }
      }
      break;  
     }
   return FALSE; 
   }
